(* ::Package:: *)

(* AutoDipole 1.2 - Package of an automated dipole subtraction by
Kouhei Hasegawa, Sven Moch, and Peter Uwer *)


(* [Code to pdoduce all P and K-terms (massless and massive cases)]
Outline
1. Create P and K-terms
2. Functions to be called  *)


PandKtermscreation:=Module[{},initializepk;createPandK;];


initializepk:=Module[{}, nfieldPKuni=nfinal+1;Do[Do[AP[i,j]=0,{i,1,100}];,{j,1,30}];copk=0;
                        pkinfo[1]=-1;pkinfo[2]=-1;
                        Do[Do[pkec[leg,i]=0;pkecM[leg,i]=0;pkecsp[leg,i]=0,{i,1,1000}],{leg,1,2}];
                        AssignPK[{A[1],A[2]},A1,1];AssignmassPK[1];plistPK[1];
                        numberPK3=Length[lightquarksPK3];
];


quarksPK={u,ubar,d,dbar,b,bbar,t,tbar};
lightquarksPK={u,ubar,d,dbar};
othersPK={e,ebar,muon,muonbar,gamma,Wp,Wm,Z,h};
massesPK={mb,mt};


createPandK:=Module[{},
If[pkexist >= 1,
Print["P and K temrs of B1:    ",{A[1],A[2]}," --> ", A1];
Print["Masses: {0,0} --> ", mlistPK];
printbar;
If[ MemberQ[lightquarksPK,AP[1,1]] || AP[1,1]===g,
Print["----------------------------------"];
Print["P and K term of Leg1: ",AP[1,1]];
Print["----------------------------------"];
pkinfo[1]=1;
PKDiagonal[1];
PKNondiagonal[1];
pk1tot=copk;copk=0;
printPKnumber[1];
,
Print["Leg 1 is non-parton: ",AP[1,1]];
pkinfo[1]=0;pk1tot=0;
];
If[ MemberQ[lightquarksPK,AP[1,2]] || AP[1,2]===g,
Print["----------------------------------"];
Print["P and K term of Leg2: ",AP[1,2]];
Print["----------------------------------"];
pkinfo[2]=1;
PKDiagonal[2];
PKNondiagonal[2];
pk2tot=copk;
printPKnumber[2];
,
Print["Leg 2 is non-parton: ",AP[1,2]];
pkinfo[2]=0;pk2tot=0;
];
Print["[Total]"];
Print["----------------------------------"];
Print["P and K term of Leg 1 ",AP[1,1],": ",pk1tot];
Print["P and K term of Leg 2 ",AP[1,2],": ",pk2tot];
pksum=pk1tot+pk2tot;
Print["All P and K term       : ",pksum];
Print["----------------------------------"];
Print["END of P and K term creation"];
If[ pkinfo[1]==1, interfaceCLBSPK[1]];
If[ pkinfo[2]==1, interfaceCLBSPK[2]];
,Print["No P and K terms exist"];
];];


PKDiagonal[leg_]:=Module[{}, 
Print["[[Diagonals]]"];
If[ MemberQ[lightquarksPK,AP[1,leg]],
Print["{Splitting (3):(a,i)=(f,g)}"];
Print["[a'=f]"];pkdip1fspec0[leg];
Print["[5.(a',k)=(f,k)]"];pkdip1spec5[leg];
Print["[6.(a',b)=(f,b)]"];pkdip1spec6[leg];
];
If[ AP[1,leg]==g,
Print["{Splitting (4):(a,i)=(g,g)}"];
Print["[a'=g]"];pkdip1gspec0[leg];
Print["[7.(a',k)=(g,k)]"];pkdip1spec7[leg];
Print["[8.(a',b)=(g,b)]"];pkdip1spec8[leg];
];
]; 


(* Splitting (3):(a,a',i)=(f,f,g) *)


pkdip1fspec0[leg_]:=Module[{},
If[ MemberQ[lightquarksPK,AP[1,leg]],
copk=copk+1;
pkec[leg,30]=pkec[leg,30]+1;
Print["\n--P",leg,"(",copk,") and K",leg,"(",copk,")--"];
P[leg,copk]=0;Print["P(",leg,",0)=",P[leg,copk]];
K[leg,copk]=K0ff;Print["K0ff(",leg,",0)=",K[leg,copk]];
emitPK[leg,copk]=leg;specPK[leg,copk]=0;
];
]; 


(* [5. spectator = k] *)


pkdip1spec5[leg_]:=Module[{},
If[ MemberQ[lightquarksPK,AP[1,leg]],
Do[If[ FreeQ[othersPK,AP[1,k]],
  copk=copk+1;
  pkec[leg,31]=pkec[leg,31]+1;
  Print["\n--P",leg,"(",copk,") and K",leg,"(",copk,")--"];
  P[leg,copk]=Pffk[leg,k];Print["Pffk(",leg,",",k,")=",P[leg,copk]];
   If[ mPK[1,k]==0 && lenmF==0,
      K[leg,copk]=Kffk[leg,k];
      Print["Kffk(",leg,",",k,")=",K[leg,copk]];
     ];
   If[ MemberQ[massesPK,mPK[1,k]] || lenmF != 0,
  pkecM[leg,31]=pkecM[leg,31]+1;
      K[copk]=KMffk[leg,k];
      Print["KMffk(",leg,",",k,")=",K[leg,copk]];
     ];
   PrintCLPK[leg,k];
  ],{k,3,nfieldpk[1]}];
]
];


(* [6. spectator = b] *)


pkdip1spec6[leg_]:=Module[{},
If[ MemberQ[lightquarksPK,AP[1,leg]],
 Do[If[ b != leg && FreeQ[othersPK,AP[1,b]],
   copk=copk+1;
   pkec[leg,32]=pkec[leg,32]+1;
   Print["\n--P",leg,"(",copk,") and K",leg,"(",copk,")--"];
   P[leg,copk]=Pffb[leg,b];Print["Pffb(",leg,",",b,")=",P[leg,copk]];
   K[leg,copk]=Kffb[leg,b];Print["Kffb(",leg,",",b,")=",K[leg,copk]];
   PrintCLPK[leg,b];
  ],{b,1,2}];
]
]; 


(* Splitting (4):(a,i)=(g,g) *)


pkdip1gspec0[leg_]:=Module[{},
If[ AP[1,leg]==g,
 copk=copk+1;
 pkec[leg,40]=pkec[leg,40]+1;
 Print["\n--P",leg,"(",copk,") and K",leg,"(",copk,")--"];
 P[leg,copk]=0;Print["P",leg,"(",leg,",0)=",P[leg,copk]];
 K[leg,copk]=K0gg;Print["K0gg",leg,"(",leg,",0)=",K[leg,copk]];
emitPK[leg,copk]=a;specPK[leg,copk]=0;
];
]; 


pkdip1spec7[leg_]:=Module[{},
If[ AP[1,leg] == g,
 Do[If[ FreeQ[othersPK,AP[1,k]],
  copk=copk+1;
  pkec[leg,41]=pkec[leg,41]+1;
  Print["\n--P",leg,"(",copk,") and K",leg,"(",copk,")--"];
  P[leg,copk]=Pggk[leg,k];Print["Pggk(",leg,",",k,")=",P[leg,copk]];
   If[ mPK[1,k]==0 && lenmF==0,
      K[leg,copk]=Kggk[leg,k];
      Print["Kggk(",leg,",",k,")=",K[leg,copk]];
     ];
   If[ MemberQ[massesPK,mPK[1,k]] || lenmF != 0,
      pkecM[leg,41]=pkecM[leg,41]+1;
      K[leg,copk]=KMggk[leg,k];
      Print["KMggk(",leg,",",k,")=",K[leg,copk]];
     ];
   PrintCLPK[leg,k];
  ],{k,3,nfieldpk[1]}];
]
]; 


pkdip1spec8[leg_]:=Module[{},
If[ AP[1,leg] == g,
 Do[If[ b != leg && FreeQ[othersPK,AP[1,b]],
   pkec[leg,42]=pkec[leg,42]+1;
   copk=copk+1;
   Print["\n--P",leg,"(",copk,") and K",leg,"(",copk,")--"];
   P[leg,copk]=Pggb[leg,b];Print["Pggb(",leg,",",b,")=",P[leg,copk]];
   K[leg,copk]=Kggb[leg,b];Print["Kggb(",leg,",",b,")=",K[leg,copk]];
   PrintCLPK[leg,b];
  ],{b,1,2}];
]
]; 


PKNondiagonal[leg_]:=Module[{}, 
Print["[[Non-Diagonals]]"];
If[ AP[1,leg]==g,PK3creation[leg];];
If[ MemberQ[lightquarksPK,AP[1,leg]],PK4creation[leg]];
]; 


(* Splitting (6):(a,a',i)=(f,g,f) *)


PK3creation[leg_]:=Module[{}, 
Print["{Splitting (6):(a,i)=(f,f)}"];
Print["[a'=g]"];
Do[
tempq=Part[lightquarksPK3,i];
tempqnum=flavornum[tempq];
Print["{(6)-",tempq,":(a,a',i)=(",tempq,",g,",tempq,")}"];
pkdip3spec0univ[tempqnum,leg];
Print["[11u.(a',k)=(g,k)]"];pkdip3spec11univ[tempqnum,leg];
Print["[12u.(a',b)=(g,b)]"];pkdip3spec12univ[tempqnum,leg];
,{i,1,numberPK3}]
]


pkdip3spec0univ[sp_,leg_]:=Module[{},
If[ AP[1,leg]==g,
 copk=copk+1;
 tempc=sp-40+600;pkec[leg,tempc]=pkec[leg,tempc]+1;
 Print["\n--P",leg,"(",copk,") and K",leg,"(",copk,")--"];
 P[leg,copk]=0;Print["P(",leg,",0)=",P[leg,copk]];
 K[leg,copk]=K0fg;Print["K0fg(",leg,",0)=",K[leg,copk]];
emitPK[leg,copk]=leg;specPK[leg,copk]=0;
];
];


pkdip3spec11univ[sp_,leg_]:=Module[{},
If[ AP[1,leg] == g,
 Do[If[ FreeQ[othersPK,AP[1,k]],
  copk=copk+1;
 tempc=sp-40+610;pkec[leg,tempc]=pkec[leg,tempc]+1;
  Print["\n--P",leg,"(",copk,") and K",leg,"(",copk,")--"];
  P[leg,copk]=Pfgk[leg,k];Print["Pfgk(",leg,",",k,")=",P[leg,copk]];
  If[ mPK[1,k]==0,
      K[leg,copk]=0;
      Print["Kfgk(",leg,",",k,")=",K[leg,copk]];
    ];
  If[ MemberQ[massesPK,mPK[1,k]],
      tempcM=sp-40+610;pkecM[leg,tempcM]=pkecM[leg,tempcM]+1;
      K[leg,copk]=KMfgk[leg,k];
      Print["KMfgk(",leg,",",k,")=",K[leg,copk]];
    ];
   PrintCLPK[leg,k];
  ],{k,3,nfieldpk[1]}];
]
]; 


pkdip3spec12univ[sp_,leg_]:=Module[{},
If[ AP[1,leg] == g,
 Do[If[ b != leg && FreeQ[othersPK,AP[1,b]],
   copk=copk+1;
   tempc=sp-40+620;pkec[leg,tempc]=pkec[leg,tempc]+1;
   Print["\n--P",leg,"(",copk,") and K",leg,"(",copk,")--"];
   P[leg,copk]=Pfgb[leg,b];Print["Pfgb(",leg,",",b,")=",P[leg,copk]];
   K[leg,copk]=Kfgb[leg,b];Print["Kfgb(",leg,",",b,")=",K[leg,copk]];
   PrintCLPK[leg,b];
  ],{b,1,2}];
]
]; 


(* Splitting (7):(a,a',i)=(g,f,fbar) *)


PK4creation[leg_]:=Module[{}, 
Print["{Splitting (7):(a,i)=(g,f)}"];
Do[PK4eachflavercreation[i,leg],{i,41,44}];
]


PK4eachflavercreation[fl_,leg_]:=Module[{},
Print["{(7)-",numflavor[fl],":(a,a')=(g,",numflavor[fl],")}"];
pkdip4spec0univ[fl,leg];
pkdip4spec13univ[fl,leg];
pkdip4spec14univ[fl,leg];
]; 


flavornum[f_]:=Which[f===u,41,f===ubar,42,f===d,43,f===dbar,44];


numflavor[fnum_]:=Which[fnum==41,u,fnum==42,ubar,fnum==43,d,fnum==44,dbar];


pkdip4spec0univ[sp_,leg_]:=Module[{},
If[ sp==flavornum[AP[1,leg]],
 copk=copk+1;
 tempc=sp-40+700;pkec[leg,tempc]=pkec[leg,tempc]+1;
 Print["\n--P",leg,"(",copk,") and K",leg,"(",copk,")--"];
 P[leg,copk]=0;Print["P(",leg,",0)=",P[leg,copk]];
 K[leg,copk]=K0gf;Print["K0gf(",leg,",0)=",K[leg,copk]];
emitPK[leg,copk]=leg;specPK[leg,copk]=0;
];
];


pkdip4spec13univ[sp_,leg_]:=Module[{},
If[ sp==flavornum[AP[1,leg]],
 Do[If[ FreeQ[othersPK,AP[1,k]],
  copk=copk+1;
  tempc=sp-40+710;pkec[leg,tempc]=pkec[leg,tempc]+1;
  Print["\n--P",leg,"(",copk,") and K",leg,"(",copk,")--"];
  P[leg,copk]=Pgfk[leg,k];Print["Pgfk(",leg,",",k,")=",P[leg,copk]];
  If[ mPK[1,k]==0,
      K[leg,copk]=0;
      Print["Kgfk(",leg,",",k,")=",K[leg,copk]];
    ];
  If[ MemberQ[massesPK,mPK[1,k]],
      tempcM=sp-40+710;pkecM[leg,tempcM]=pkecM[leg,tempcM]+1;
      K[leg,copk]=KMgfk[leg,k];
      Print["KMgfk(",leg,",",k,")=",K[leg,copk]];
    ];
   PrintCLPK[leg,k];
  ],{k,3,nfieldpk[1]}];
]
];


pkdip4spec14univ[sp_,leg_]:=Module[{},
If[ sp==flavornum[AP[1,leg]],
 Do[If[ b != leg && FreeQ[othersPK,AP[1,b]],
   copk=copk+1;
   tempc=sp-40+720;pkec[leg,tempc]=pkec[leg,tempc]+1;
   Print["\n--P",leg,"(",copk,") and K",leg,"(",copk,")--"];
   P[leg,copk]=Pgfb[leg,b];Print["Pgfb(",leg,",",b,")=",P[leg,copk]];
   K[leg,copk]=Kgfb[leg,b];Print["Kgfb(",leg,",",b,")=",K[leg,copk]];
   PrintCLPK[leg,b];
  ],{b,1,2}];
]
];


printPKnumber[leg_]:=Module[{},
pkecsp[leg,3]=pkec[leg,30]+pkec[leg,31]+pkec[leg,32];
pkecsp[leg,4]=pkec[leg,40]+pkec[leg,41]+pkec[leg,42];
pkecsp[leg,61]=pkec[leg,601]+pkec[leg,611]+pkec[leg,621];
pkecsp[leg,62]=pkec[leg,602]+pkec[leg,612]+pkec[leg,622];
pkecsp[leg,63]=pkec[leg,603]+pkec[leg,613]+pkec[leg,623];
pkecsp[leg,64]=pkec[leg,604]+pkec[leg,614]+pkec[leg,624];
pkecsp[leg,71]=pkec[leg,701]+pkec[leg,711]+pkec[leg,721];
pkecsp[leg,72]=pkec[leg,702]+pkec[leg,712]+pkec[leg,722];
pkecsp[leg,73]=pkec[leg,703]+pkec[leg,713]+pkec[leg,723];
pkecsp[leg,74]=pkec[leg,704]+pkec[leg,714]+pkec[leg,724];
pkdiagonal[leg]=pkecsp[leg,3]+pkecsp[leg,4];
pknondiagonal6[leg]=pkecsp[leg,61]+pkecsp[leg,62]+pkecsp[leg,63]+pkecsp[leg,64];
pknondiagonal7[leg]=pkecsp[leg,71]+pkecsp[leg,72]+pkecsp[leg,73]+pkecsp[leg,74];
pknondiagonal[leg]=pknondiagonal6[leg]+pknondiagonal7[leg];
pktotal[leg]=pkdiagonal[leg]+pknondiagonal[leg];
pktotalM[leg]=pkecM[leg,31]+pkecM[leg,41]+pkecM[leg,611]+pkecM[leg,612]
+pkecM[leg,613]+pkecM[leg,614]+pkecM[leg,711]+pkecM[leg,712]+pkecM[leg,713]+pkecM[leg,714];

Do[
sepPK1[leg,j]=0;
sepPK3u[leg,j]=0;
sepPK3ubar[leg,j]=0;
sepPK3d[leg,j]=0;
sepPK3dbar[leg,j]=0;
sepPK4u[leg,j]=0;
sepPK4ubar[leg,j]=0;
sepPK4d[leg,j]=0;
sepPK4dbar[leg,j]=0;
,{j,1,2}];

If[ pkdiagonal[leg] >=1,
sepPK1[leg,1]=1;
sepPK1[leg,2]=pkdiagonal[leg];
];
tempPK3=pkdiagonal[leg];
If[ pkecsp[leg,61] >=1,
sepPK3u[leg,1]=tempPK3+1;
sepPK3u[leg,2]=tempPK3+pkecsp[leg,61];
];
If[ pkecsp[leg,62] >=1,
sepPK3ubar[leg,1]=tempPK3+pkecsp[leg,61]+1;
sepPK3ubar[leg,2]=tempPK3+pkecsp[leg,61]+pkecsp[leg,62];
];
If[ pkecsp[leg,63] >=1,
sepPK3d[leg,1]=tempPK3+pkecsp[leg,61]+pkecsp[leg,62]+1;
sepPK3d[leg,2]=tempPK3+pkecsp[leg,61]+pkecsp[leg,62]+pkecsp[leg,63];
];
If[ pkecsp[leg,64] >=1,
sepPK3dbar[leg,1]=tempPK3+pkecsp[leg,61]+pkecsp[leg,62]+pkecsp[leg,63]+1;
sepPK3dbar[leg,2]=tempPK3+pknondiagonal6[leg];
];
tempPK4=pkdiagonal[leg]+pknondiagonal6[leg];
If[ pkecsp[leg,71] >=1,
sepPK4u[leg,1]=tempPK4+1;
sepPK4u[leg,2]=tempPK4+pkecsp[leg,71];
];
If[ pkecsp[leg,72] >=1,
sepPK4ubar[leg,1]=tempPK4+pkecsp[leg,71]+1;
sepPK4ubar[leg,2]=tempPK4+pkecsp[leg,71]+pkecsp[leg,72];
];
If[ pkecsp[leg,73] >=1,
sepPK4d[leg,1]=tempPK4+pkecsp[leg,71]+pkecsp[leg,72]+1;
sepPK4d[leg,2]=tempPK4+pkecsp[leg,71]+pkecsp[leg,72]+pkecsp[leg,73];
];
If[ pkecsp[leg,74] >=1,
sepPK4dbar[leg,1]=tempPK4+pkecsp[leg,71]+pkecsp[leg,72]+pkecsp[leg,73]+1;
sepPK4dbar[leg,2]=tempPK4+pknondiagonal7[leg];
];

Print["--------------------------------------"];
Print["Number of P and K terms Leg",leg];
Print["Diagonals:  ", pkdiagonal[leg]];
Print["(3) (a,a',i)=(f,f,g):  ", pkecsp[leg,3]];
Print["              [K0ff]   ", pkec[leg,30]];
Print["              [5. k]   ", pkec[leg,31], " (", pkecM[leg,31],")"];
Print["              [6. b]   ", pkec[leg,32]];
Print["(4) (a,a',i)=(g,g,g):  ", pkecsp[leg,4]];
Print["              [K0gg]   ", pkec[leg,40]];
Print["              [7. k]   ", pkec[leg,41], " (", pkecM[leg,41],")"];
Print["              [8. b]   ", pkec[leg,42]];
Print["Non-diagonals:  ", pknondiagonal[leg]];
Print["(6) (a,a',i)=(f,g,f):  ", pknondiagonal6[leg]];
If[ pknondiagonal6[leg]>= 1,
Print["    (6)-u (a,a',i)=(u,g,u):  ", pkecsp[leg,61]];
Print["              [K0ug]   ", pkec[leg,601]];
Print["              [11u. k]   ", pkec[leg,611], " (", pkecM[leg,611],")"];
Print["              [12u. b]   ", pkec[leg,621]];
Print["    (6)-ubar (a,a',i)=(ubar,g,ubar):  ", pkecsp[leg,62]];
Print["              [K0ubarg]   ",   pkec[leg,602]];
Print["              [11ubar. k]   ", pkec[leg,612], " (", pkecM[leg,612],")"];
Print["              [12ubar. b]   ", pkec[leg,622]];
Print["    (6)-d (a,a',i)=(d,g,d):  ", pkecsp[leg,63]];
Print["              [K0dg]   ", pkec[leg,603]];
Print["              [11d. k]   ", pkec[leg,613], " (", pkecM[leg,613],")"];
Print["              [12d. b]   ", pkec[leg,623]];
Print["    (6)-dbar (a,a',i)=(dbar,g,dbar):  ", pkecsp[leg,64]];
Print["              [K0dbarg]   ", pkec[leg,604]];
Print["              [11dbar. k]   ", pkec[leg,614], " (", pkecM[leg,614],")"];
Print["              [12dbar. b]   ", pkec[leg,624]];
];
Print["(7) (a,a',i)=(g,f,fbar):  ", pknondiagonal7[leg]];
If[ pknondiagonal7[leg]>= 1,
Print["    (7)-u (a,a',i)=(g,ubar,u):  ", pkecsp[leg,71]];
Print["              [K0gubar]   ", pkec[leg,701]];
Print["              [13u. k]   ", pkec[leg,711], " (", pkecM[leg,711],")"];
Print["              [14u. b]   ", pkec[leg,721]];
Print["    (7)-ubar (a,a',i)=(g,u,ubar):  ", pkecsp[leg,72]];
Print["              [K0gu]   ", pkec[leg,702]];
Print["              [13ubar. k]   ", pkec[leg,712], " (", pkecM[leg,712],")"];
Print["              [14ubar. b]   ", pkec[leg,722]];
Print["    (7)-d (a,a',i)=(g,dbar,d):  ", pkecsp[leg,73]];
Print["              [K0gdbar]   ", pkec[leg,703]];
Print["              [13d. k]   ",  pkec[leg,713], " (", pkecM[leg,713],")"];
Print["              [14d. b]   ", pkec[leg,723]];
Print["    (7)-dbar (a,a',i)=(g,d,dbar):  ", pkecsp[leg,74]];
Print["              [K0gd]   ", pkec[leg,704]];
Print["              [13dbar. k]   ", pkec[leg,714], " (", pkecM[leg,714],")"];
Print["              [14dbar. b]   ", pkec[leg,724]];
];
Print["-------------------"];
 (* Total*)
If[pktotal[leg]==copk,
Print["[Total]"];
Print["P term : ",pktotal[leg]];
Print["K term : ",pktotal[leg]," (",pktotalM[leg],")"];
,Print["Count error"];];
Print[" "];
Print["1:                  ",sepPK1[leg,1],"-",sepPK1[leg,2]];
Print["3u:                 ",sepPK3u[leg,1],"-",sepPK3u[leg,2]];
Print["3ubar:              ",sepPK3ubar[leg,1],"-",sepPK3ubar[leg,2]];
Print["3d:                 ",sepPK3d[leg,1],"-",sepPK3d[leg,2]];
Print["3dbar:              ",sepPK3dbar[leg,1],"-",sepPK3dbar[leg,2]];
Print["4u:                 ",sepPK4u[leg,1],"-",sepPK4u[leg,2]];
Print["4ubar:              ",sepPK4ubar[leg,1],"-",sepPK4ubar[leg,2]];
Print["4d:                 ",sepPK4d[leg,1],"-",sepPK4d[leg,2]];
Print["4dbar:              ",sepPK4dbar[leg,1],"-",sepPK4dbar[leg,2]];
Print["-------------------"];
Print["END"];
]


interfaceCLBSPK[leg_]:=Module[{},
Do[matchkindPK[leg,i]=-1;matchPK[leg,i]=0;,{i,1,pktotal[leg]}];
matchPK[1,pktotal[leg],sepD1initial[1],sepD1initial[2],leg]
];


matchPK[initialPK_,finalPK_,initialD_,finalD_,leg_]:=Module[{},
Do[
 If[specPK[leg,i]==0,matchkindPK[leg,i]=-2;matchPK[leg,i]=0;,
   Do[If[emitPK[leg,i]==emit[j] && specPK[leg,i]==spec[j],matchkindPK[leg,i]=0;matchPK[leg,i]=j;
     (*Print["Direct match"]*);Break[]];,{j,initialD,finalD}];
   If[matchPK[leg,i]==0,
      (*Print["Miss-Direct match"];*)
      emitspecifcasePK[i,initialD,finalD,leg];
     ]; 
  ];
,{i,initialPK,finalPK}];
];


emitspecifcasePK[i_,initialD_,finalD_,leg_]:=Module[{},
   Print["PKterm(",i,"): (",emitPK[leg,i],",",specPK[leg,i],")=(i,f)"];
   calllistPK[i,specPK[leg,i]];
   Do[exlistPK[i,k]={emitPK[leg,i],Part[samelistPK[i],k]},{k,1,lensamePK[i]}];
   Do[
     Do[
       If[emitPK[leg,i] == emit[j] && Part[exlistPK[i,k],2] == spec[j], matchPK[leg,i]=j;
        exmomPK[leg,i]={spec[j],specPK[leg,i]};matchkindPK[leg,i]=1;
        Print["Momentum exchange match:",exmomPK[leg,i]];
        Break[]];
      ,{j,initialD,finalD}];
     If[matchPK[i] != 0, Break[]]
  ,{k,1,lensamePK[i]}]; 
];


calllistPK[i_,specleg_]:=Module[{},
temp=AP[1,specleg];temp2=ToString[temp];temp3=StringJoin[temp2,"listPK[1]"];
samelistPK[i]=ToExpression[temp3];lensamePK[i]=Length[samelistPK[i]]
]


(* 2. Functions to be called *)


(* Dipole 1*)


(* (3) (a,a',i)=(f,f,g)  *)


K0ff:=AL*(2*Pi)^(-1)*(Kbarff - KFSff)*CLPK[copk];


Kbarff:=CF*(
plusd[2*(1-x)^(-1)*Log[(1-x)*(x)^(-1)]] -
(1+x)*Log[(1-x)*(x)^(-1)]+1-x
)-delta[1-x]*(5-Pi^2)*CF;


(* [5. spectator = k] *)


Pffk[a_,k_]:=AL*(2*Pi)^(-1)*Pff*CF^(-1)*CLPK[copk]*Log[muF^(2)*(x*scpk[a,k])^(-1)];


Kffk[a_,k_]:=Which[MemberQ[quarksPK,AP[1,k]],Kfff[a,k],AP[1,k]==g,Kffg[a,k]]//Simplify;


Kfff[a_,k_]:=AL*(2*Pi)^(-1)*gammaf*CF^(-1)*CLPK[copk]*(plusd[1*(1-x)^(-1)]+delta[1-x]);


Kffg[a_,k_]:=AL*(2*Pi)^(-1)*gammag*CA^(-1)*CLPK[copk]*(plusd[1*(1-x)^(-1)]+delta[1-x]);


(* Massive K term *)


KMffk[a_,k_]:=-AL*(2*Pi)^(-1)*CLPK[copk]*(
Kappaffk[a,k] + CF^(-1)*(
Pffreg*Log[(1-x)*scpk[a,k]*((1-x)*scpk[a,k]+mPK[1,k]^(2))^(-1)]
+gammaf*delta[1-x]*fkm1[a,k]));//Simplify


Kappaffk[a_,k_]:=Which[MemberQ[quarksPK,AP[1,k]],Kappafff[a,k],AP[1,k]==g,Kappaffg[a,k]];


Kappafff[a_,k_]:=2*(plusd[Log[1-x]*(1-x)^(-1)] - Log[2-x]*(1-x)^(-1))+
2*plusd[(1-x)^(-1)]*Log[(2-x)*scpk[a,k]*((2-x)*scpk[a,k]+mPK[1,k]^(2))^(-1)]-
gammaf*CF^(-1)*delta[1-x]+delta[1-x]*(
mPK[1,k]^(2)*scpk[a,k]^(-1)*Log[mPK[1,k]^(2)*(scpk[a,k]+mPK[1,k]^(2))^(-1)]
+2^(-1)*mPK[1,k]^(2)*(scpk[a,k]+mPK[1,k]^(2))^(-1)
)+JfgFplusd[a,k]//Simplify;


Kappaffg[a_,k_]:=-gammag*CA^(-1)*(plusd[(1-x)^(-1)] +delta[1-x])+
TR*CA^(-1)*Sum[dec[scpk[a,k],mPK[1,k],Part[mFlist,n]]*nFakPK1[a,k,Part[mFlist,n]],{n,1,lenmF}]//Simplify;


nFakPK1[a_,k_,mFPK_]:=(delta[1-x] + delta[plusd[x] - x])*
(2*3^(-1)*(Log[mFPK^(2)*scpk[a,k]^(-1)] +5*3^(-1)) - JfFFNS[a,k,mFPK])+
JfFFplusd[a,k,mFPK] + delta[1-x]*2*3^(-1)*(1-4*mFPK^(2)*scpk[a,k]^(-1))^(2/3)//Simplify;


(* [6. spectator = b] *)


Pffb[a_,b_]:=Pffk[a,b];


Kffb[a_,b_]:=-AL*(2*Pi)^(-1)*CLPK[copk]*CF^(-1)*(
Pffreg*log[1-x] + CF*(plusd[2*(1-x)^(-1)*Log[1-x]] - Pi^(2)*3^(-1)*delta[1-x]));


(* (4) (a,a',i)=(g,g,g)  *)


K0gg:=AL*(2*Pi)^(-1)*(Kbargg - KFSgg)*CLPK[copk];


Kbargg:=2*CA*(plusd[1*(1-x)^(-1)*Log[(1-x)*(x)^(-1)]] +
((1-x)*x^(-1) - 1 + x*(1-x) )*Log[(1-x)*(x)^(-1)])-delta[1-x]*((50*9^(-1)-Pi^2)*CA 
- 16*9^(-1)*TR*Nf)//Simplify;


(* [7. spectator = k] *)


Pggk[a_,k_]:=AL*(2*Pi)^(-1)*Pgg*CA^(-1)*CLPK[copk]*Log[muF^(2)*(x*scpk[a,k])^(-1)];


Kggk[a_,k_]:=Which[MemberQ[quarksPK,AP[1,k]],Kggf[a,k],AP[1,k]==g,Kggg[a,k]]//Simplify;


Kggf[a_,k_]:=AL*(2*Pi)^(-1)*gammaf*CF^(-1)*CLPK[copk]*(plusd[1*(1-x)^(-1)]+delta[1-x]);


Kggg[a_,k_]:=AL*(2*Pi)^(-1)*gammag*CA^(-1)*CLPK[copk]*(plusd[1*(1-x)^(-1)]+delta[1-x]);


(* Massive K term *)


KMggk[a_,k_]:=-AL*(2*Pi)^(-1)*CLPK[copk]*(
Kappaggk[a,k] + CA^(-1)*(
Pggreg*Log[(1-x)*scpk[a,k]*((1-x)*scpk[a,k]+mPK[1,k]^(2))^(-1)]
+gammag*delta[1-x]*fkm1[a,k]));//Simplify


Kappaggk[a_,k_]:=Which[MemberQ[quarksPK,AP[1,k]],Kappaggf[a,k],AP[1,k]==g,Kappaggg[a,k]];


Kappaggf[a_,k_]:=Kappafff[a,k]+CA*CF^(-1)*Kappafgf[a,k];


Kappafgf[a_,k_]:=2*CF*CA^(-1)*mPK[1,k]^(2)*(x*scpk[a,k])^(-1)*Log[mPK[1,k]^(2)*
((1-x)*scpk[a,k]+mPK[1,k]^(2))^(-1)];


Kappaggg[a_,k_]:=Kappaffg[a,k];


(* [8. spectator = b] *)


Pggb[a_,b_]:=Pggk[a,b];


Kggb[a_,b_]:=-AL*(2*Pi)^(-1)*CLPK[copk]*CA^(-1)*(
Pggreg*log[1-x] + CA*(plusd[2*(1-x)^(-1)*Log[1-x]] - Pi^(2)*3^(-1)*delta[1-x]));


(* (6):(a,a',i)=(f,g,f) *)


K0fg:=AL*(2*Pi)^(-1)*(Kbarfg - KFSfg)*CLPK[copk];


Kbarfg:=Pfg*Log[(1-x)*x^(-1)]+CF*x;


(* [11. spectator = k] *)


Pfgk[a_,k_]:=AL*(2*Pi)^(-1)*Pfg*CA^(-1)*CLPK[copk]*Log[muF^(2)*(x*scpk[a,k])^(-1)];


(* Massive K term *)


KMfgk[a_,k_]:=-AL*(2*Pi)^(-1)*CLPK[copk]*(Kappafgk[a,k] + 
CA^(-1)*Pfgreg*Log[(1-x)*scpk[a,k]*((1-x)*scpk[a,k]+mPK[1,k]^(2))^(-1)])//Simplify;


Kappafgk[a_,k_]:=Which[MemberQ[quarksPK,AP[1,k]],Kappafgf[a,k],AP[1,k]==g,Kappafgg[a,k]];


Kappafgg[a_,k_]:=0;


(* [12. spectator = b] *)


Pfgb[a_,b_]:=Pfgk[a,b];


Kfgb[a_,b_]:=-AL*(2*Pi)^(-1)*CLPK[copk]*CA^(-1)*Pfgreg*log[1-x];


(* (7):(a,a',i)=(g,f,fbar) *)


K0gf:=AL*(2*Pi)^(-1)*(Kbargf - KFSgf)*CLPK[copk];


Kbargf:=Pgf*Log[(1-x)*x^(-1)]+TR*2*x*(1-x);


(* [13. spectator = k] *)


Pgfk[a_,k_]:=AL*(2*Pi)^(-1)*Pgf*CF^(-1)*CLPK[copk]*Log[muF^(2)*(x*scpk[a,k])^(-1)];


(* Massive K term *)


KMgfk[a_,k_]:=-AL*(2*Pi)^(-1)*CLPK[copk]*CF^(-1)*Pgfreg*
Log[(1-x)*scpk[a,k]*((1-x)*scpk[a,k]+mPK[1,k]^(2))^(-1)]//Simplify;


(* [14. spectator = b] *)


Pgfb[a_,b_]:=Pgfk[a,b];


Kgfb[a_,b_]:=-AL*(2*Pi)^(-1)*CLPK[copk]*CF^(-1)*Pgfreg*Log[1-x]//Simplify;


(* Common functions *)


Pff:=CF*plusd[(1+x^2)*(1-x)^(-1)];


Pgg:=2*CA*(plusd[(1-x)^(-1)]+(1-x)*x^(-1)-1+x*(1-x))+delta[1-x]*(11*6^(-1)*CA-2*3^(-1)*TR*Nf);


Pfg:=CF*(1+(1-x)^2)*x^(-1);


Pgf:=TR*(x^(2)+(1-x)^2);


Pffreg:=-CF*(1+x);


Pggreg:=2*CA*((1-x)*x^(-1)-1+x*(1-x));


Pfgreg:=Pfg;


Pgfreg:=Pgf;


gammaf:=3*2^(-1)*CF;


gammag:=11*6^(-1)*CA - 2*3^(-1)*TR*Nf;


fkm1[a_,k_]:=Log[(scpk[a,k] - 2*mPK[1,k]*Sqrt[scpk[a,k]+mPK[1,k]^(2)]+2*mPK[1,k]^(2))*(scpk[a,k])^(-1)]+
2*mPK[1,k]*(Sqrt[scpk[a,k]+mPK[1,k]^(2)] + mPK[1,k])^(-1);


JfgFplusd[a_,k_]:=plusd[(1-x)*(2*(1-x+muQk[a,k]^(2))^(2))^(-1) - 2*(1-x)^(-1)*(1+Log[1-x+muQk[a,k]^(2)])]+
plusd[2*(1-x)^(-1)]*Log[2+muQk[a,k]^(2)-x]//Simplify;


JfFFplusd[a_,k_,mFPK_]:=2*3^(-1)*plusd[(1-x+2*muQF[a,k,mFPK]^(2))*((1-x)^(2))^(-1)*
Sqrt[1-4*muQF[a,k,mFPK]^(2)*(1-x)^(-1)]]//Simplify;


JfFFNS[a_,k_,mFPK_]:=10*9^(-1)*(1-Sqrt[1-4*muQF[a,k,mFPK]^(2)]) - 8*9^(-1)*muQF[a,k,mFPK]^(2)*
Sqrt[1-4*muQF[a,k,mFPK]^(2)]+4*3^(-1)*Log[(1+Sqrt[1-4*muQF[a,k,mFPK]^(2)])*(2)^(-1)]//Simplify;


muQk[a_,k_]:=mPK[1,k]/Sqrt[scpk[a,k]];


muQF[a_,k_,mFPK_]:=mFPK/Sqrt[scpk[a,k]];


(* Common subroutines *)


AssignPK[ilist_,flist_,i_]:=Module[{}, 
nfinalpk=Length[flist];nfieldpk[i]=2+nfinalpk;
AP[i,1]=Part[ilist,1];AP[i,2]=Part[ilist,2];
Do[AP[i,j+2]=Part[flist,j],{j,1,nfinalpk}];
]


AssignmassPK[i_]:=Module[{}, 
mlistPK={};Do[
             If[AP[i,j]==g||AP[i,j]==u||AP[i,j]==ubar||AP[i,j]==d||AP[i,j]==dbar,mPK[i,j]=0];
             If[AP[i,j]==b||AP[i,j]==bbar,mPK[i,j]=mb];
             If[AP[i,j]==t||AP[i,j]==tbar,mPK[i,j]=mt];
\[NonBreakingSpace]            If[AP[i,j]==Wp||AP[i,j]==Wm,mPK[i,j]=mw];
\[NonBreakingSpace]            If[AP[i,j]==Z,mPK[i,j]=mz];
             If[AP[i,j]==e||AP[i,j]==ebar,mPK[i,j]=0];
             If[AP[i,j]==muon||AP[i,j]==muonbar,mPK[i,j]=0];
\[NonBreakingSpace]            If[AP[i,j]==h,mPK[i,j]=mh];
             AppendTo[mlistPK,mPK[i,j]];
             ,{j,3,nfieldpk[i]}];
]


PrintCLPK[i_,k_]:=Module[{},Print["CLPK(",copk,")=CLBS(",i,",",k,")"];
emitPK[i,copk]=i;specPK[i,copk]=k;];


scpk[i_,j_]:=If[i>j,tmp={ToString[s],ToString[j],ToString[i]};
tmp2=StringJoin[tmp];ToExpression[tmp2],
tmp={ToString[s],ToString[i],ToString[j]};
tmp2=StringJoin[tmp];ToExpression[tmp2]];


plistPK[s_]:=Module[{},glistPK[s]={};ulistPK[s]={};ubarlistPK[s]={};dlistPK[s]={};dbarlistPK[s]={};
                          blistPK[s]={};bbarlistPK[s]={};tlistPK[s]={};tbarlistPK[s]={};
                 Do[If[AP[s,i]==g,AppendTo[glistPK[s],i],Null],{i,3,nfieldpk[s]}];
                 Do[If[AP[s,i]==u,AppendTo[ulistPK[s],i]],{i,3,nfieldpk[s]}];
                 Do[If[AP[s,i]==ubar,AppendTo[ubarlistPK[s],i]],{i,3,nfieldpk[s]}];
                 Do[If[AP[s,i]==d,AppendTo[dlistPK[s],i]],{i,3,nfieldpk[s]}];
                 Do[If[AP[s,i]==dbar,AppendTo[dbarlistPK[s],i]],{i,3,nfieldpk[s]}];
                 Do[If[AP[s,i]==b,AppendTo[blistPK[s],i]],{i,3,nfieldpk[s]}];
                 Do[If[AP[s,i]==bbar,AppendTo[bbarlistPK[s],i]],{i,3,nfieldpk[s]}];
                 Do[If[AP[s,i]==t,AppendTo[tlistPK[s],i]],{i,3,nfieldpk[s]}];
                 Do[If[AP[s,i]==tbar,AppendTo[tbarlistPK[s],i]],{i,3,nfieldpk[s]}];
                 ]


printbar:=Print["----------------------------------------------------------------------------"];
